#
# spec file for package qemu-linux-user
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           qemu-linux-user
Url:            http://www.qemu.org/
Summary:        Universal CPU emulator
License:        BSD-3-Clause and GPL-2.0 and GPL-2.0+ and LGPL-2.1+ and MIT
Group:          System/Emulators/PC
Version:        2.10.0
Release:        0
Source:         qemu-2.10.0.tar.xz
# Upstream First -- http://wiki.qemu-project.org/Contribute/SubmitAPatch
# This patch queue is auto-generated from https://github.com/openSUSE/qemu
Patch0001:      0001-XXX-dont-dump-core-on-sigabort.patch
Patch0002:      0002-qemu-binfmt-conf-Modify-default-pat.patch
Patch0003:      0003-qemu-cvs-gettimeofday.patch
Patch0004:      0004-qemu-cvs-ioctl_debug.patch
Patch0005:      0005-qemu-cvs-ioctl_nodirection.patch
Patch0006:      0006-linux-user-add-binfmt-wrapper-for-a.patch
Patch0007:      0007-PPC-KVM-Disable-mmu-notifier-check.patch
Patch0008:      0008-linux-user-fix-segfault-deadlock.patch
Patch0009:      0009-linux-user-binfmt-support-host-bina.patch
Patch0010:      0010-linux-user-Fake-proc-cpuinfo.patch
Patch0011:      0011-linux-user-XXX-disable-fiemap.patch
Patch0012:      0012-linux-user-use-target_ulong.patch
Patch0013:      0013-console-add-question-mark-escape-op.patch
Patch0014:      0014-Make-char-muxer-more-robust-wrt-sma.patch
Patch0015:      0015-linux-user-lseek-explicitly-cast-no.patch
Patch0016:      0016-AIO-Reduce-number-of-threads-for-32.patch
Patch0017:      0017-xen_disk-Add-suse-specific-flush-di.patch
Patch0018:      0018-qemu-bridge-helper-reduce-security-.patch
Patch0019:      0019-qemu-binfmt-conf-use-qemu-ARCH-binf.patch
Patch0020:      0020-configure-Fix-detection-of-seccomp-.patch
Patch0021:      0021-linux-user-properly-test-for-infini.patch
Patch0022:      0022-roms-Makefile-pass-a-packaging-time.patch
Patch0023:      0023-Raise-soft-address-space-limit-to-h.patch
Patch0024:      0024-increase-x86_64-physical-bits-to-42.patch
Patch0025:      0025-vga-Raise-VRAM-to-16-MiB-for-pc-0.1.patch
Patch0026:      0026-i8254-Fix-migration-from-SLE11-SP2.patch
Patch0027:      0027-acpi_piix4-Fix-migration-from-SLE11.patch
Patch0028:      0028-Fix-tigervnc-long-press-issue.patch
Patch0029:      0029-string-input-visitor-Fix-uint64-par.patch
Patch0030:      0030-test-string-input-visitor-Add-int-t.patch
Patch0031:      0031-test-string-input-visitor-Add-uint6.patch
Patch0032:      0032-tests-Add-QOM-property-unit-tests.patch
Patch0033:      0033-tests-Add-scsi-disk-test.patch
Patch0034:      0034-slirp-fix-clearing-ifq_so-from-pend.patch
Patch0035:      0035-s390-ccw-Fix-alignment-for-CCW1.patch
Patch0036:      0036-target-i386-cpu-Add-new-EPYC-CPU-mo.patch
Patch0037:      0037-chardev-baum-fix-baum-that-releases.patch
# Please do not add QEMU patches manually here.
# Run update_git.sh to regenerate this queue.
Source400:      update_git.sh
ExcludeArch:    s390
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#!BuildIgnore:  gcc-PIE
BuildRequires:  e2fsprogs-devel
BuildRequires:  fdupes
BuildRequires:  gcc-c++
%if 0%{?suse_version} >= 1140
BuildRequires:  glib2-devel-static
%else
BuildRequires:  glib2-devel
%endif
%if 0%{?suse_version} >= 1210
BuildRequires:  glibc-devel-static
%endif
%if 0%{?suse_version} >= 1210
BuildRequires:  libattr-devel-static
%else
BuildRequires:  libattr-devel
%endif
%if 0%{?suse_version} > 1220
BuildRequires:  makeinfo
%endif
%if 0%{?suse_version} >= 1220
BuildRequires:  pcre-devel-static
%endif
BuildRequires:  python
%if 0%{?suse_version} >= 1120
BuildRequires:  zlib-devel-static
%else
BuildRequires:  zlib-devel
%endif
# we must not install the qemu-linux-user package when under QEMU build
%if 0%{?qemu_user_space_build:1}
#!BuildIgnore:  post-build-checks
%endif
Provides:       qemu:%_bindir/qemu-arm

%description
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains statically linked binaries for running linux-user
emulations. This can be used together with the OBS build script to
run cross-architecture builds.

%prep
%setup -q -n qemu-2.10.0
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1

%build
./configure \
	--prefix=%_prefix \
	--sysconfdir=%_sysconfdir \
	--libdir=%_libdir \
	--libexecdir=%_libexecdir \
	--localstatedir=%_localstatedir \
	--extra-cflags="%{optflags}" \
	--disable-stack-protector \
	--disable-strip \
	--disable-system --enable-linux-user \
	--disable-tools --disable-guest-agent \
	--static \
	--disable-modules \
	--disable-pie \
	--disable-docs \
	--audio-drv-list="" \
	--enable-attr \
	--disable-blobs \
	--disable-bluez \
	--disable-brlapi \
	--disable-bzip2 \
	--disable-cap-ng \
	--enable-coroutine-pool \
	--disable-curl \
	--disable-curses \
	--disable-fdt \
	--disable-gcrypt \
	--disable-glusterfs \
	--disable-gnutls \
	--disable-gtk \
	--disable-hax \
	--disable-jemalloc \
	--disable-kvm \
	--disable-libiscsi \
	--disable-linux-aio \
	--disable-lzo \
	--disable-netmap \
	--disable-nettle \
	--disable-numa \
	--disable-opengl \
	--without-pixman \
	--disable-rbd \
	--disable-rdma \
	--disable-replication \
	--disable-sdl \
	--disable-seccomp \
	--disable-smartcard \
	--disable-snappy \
	--disable-spice \
	--disable-tcmalloc \
	--disable-tpm \
	--disable-usb-redir \
	--disable-vde \
	--disable-vhost-net \
	--disable-virglrenderer \
	--disable-virtfs \
	--disable-vnc \
	--disable-vnc-jpeg \
	--disable-vnc-png \
	--disable-vnc-sasl \
	--disable-vte \
	--disable-xen \
	--disable-xen-pci-passthrough \
	--disable-xen-pv-domain-build \
	--disable-xfsctl \

%if 0%{?suse_version} == 1140
# -lrt needs to come after -lglib-2.0 to avoid undefined clock_gettime
sed -i "s/-lglib-2.0/-lglib-2.0 -lrt/" config-host.mak
%endif
make %{?_smp_mflags} V=1

%ifarch %ix86
%define qemu_arch i386
%endif
%ifarch x86_64
%define qemu_arch x86_64
%endif
%ifarch %arm
%define qemu_arch arm
%endif
%ifarch aarch64
%define qemu_arch aarch64
%endif
%ifarch ppc
%define qemu_arch ppc
%endif
%ifarch ppc64
%define qemu_arch ppc64
%endif
%ifarch ppc64le
%define qemu_arch ppc64le
%endif
%ifarch s390x
%define qemu_arch s390x
%endif

%ifarch %ix86 x86_64 %arm aarch64 ppc ppc64 ppc64le s390x
%if 0%{?suse_version} >= 1310
%check
%{qemu_arch}-linux-user/qemu-%{qemu_arch} %_bindir/ls > /dev/null
%endif
%endif

%install
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}%_datadir/qemu/keymaps
unlink %{buildroot}%_datadir/qemu/trace-events-all
unlink %{buildroot}%_libexecdir/qemu-bridge-helper
install -d -m 755 %{buildroot}%_sbindir
install -m 755 scripts/qemu-binfmt-conf.sh %{buildroot}%_sbindir
%ifnarch %ix86 x86_64
ln -sf ../../../emul/ia32-linux %{buildroot}%_datadir/qemu/qemu-i386
%endif
mkdir -p %{buildroot}/emul/ia32-linux
%fdupes -s %{buildroot}

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%_bindir/qemu-aarch64
%_bindir/qemu-alpha
%_bindir/qemu-arm
%_bindir/qemu-armeb
%_bindir/qemu-cris
%_bindir/qemu-hppa
%_bindir/qemu-i386
%_bindir/qemu-m68k
%_bindir/qemu-microblaze
%_bindir/qemu-microblazeel
%_bindir/qemu-mips
%_bindir/qemu-mipsel
%_bindir/qemu-mipsn32
%_bindir/qemu-mipsn32el
%_bindir/qemu-mips64
%_bindir/qemu-mips64el
%_bindir/qemu-nios2
%_bindir/qemu-or1k
%_bindir/qemu-ppc64abi32
%_bindir/qemu-ppc64
%_bindir/qemu-ppc64le
%_bindir/qemu-ppc
%_bindir/qemu-s390x
%_bindir/qemu-sh4
%_bindir/qemu-sh4eb
%_bindir/qemu-sparc32plus
%_bindir/qemu-sparc64
%_bindir/qemu-sparc
%_bindir/qemu-tilegx
%_bindir/qemu-x86_64
%_bindir/qemu-*-binfmt
%_sbindir/qemu-binfmt-conf.sh
%ifnarch %ix86 x86_64
%dir /emul/ia32-linux
%dir %_datadir/qemu
%_datadir/qemu/qemu-i386
%endif

%changelog
